//////////////////////////////////////////////////////////////////////
//
//  DBBROWSE.PRG
//
//  Copyright:
//      Alaska Software, (c) 1997-2006. Alle Rechte vorbehalten.         
//  
//  Inhalt:
//      Beispiel fuer XbpBrowse
//   
//  Bemerkungen:
//      Ein einfaches Test Programm das den Browser auf einer Datenbank
//      demonstriert.
//   
//  Syntax:
//      DBBROWSE [<cDBFName>]
//   
//  Return:
//      gibt immer 0 zurueck
//   
//////////////////////////////////////////////////////////////////////

#include "Appevent.ch"
#include "Common.ch"
#include "Font.ch"

#include "DBFDBE.CH"
#include "NTXDBE.CH"
#include "FOXDBE.CH"
#include "CDXDBE.CH"

// Text-Konstanten
#define MSG_DBFDBE_NOT_LOADED   "Database-Engine DBFDBE nicht geladen"
#define MSG_NTXDBE_NOT_LOADED   "Database-Engine NTXDBE nicht geladen"
#define MSG_DBFNTX_NOT_CREATED  "DBFNTX Database-Engine;konnte nicht erzeugt werden" 
 
PROCEDURE AppSys
   // es wird keine XbpCrt Instanz erzeugt
RETURN
 
PROCEDURE DbeSys
   // Dieses Programm verwendet keine Index Dateien, daher werden
   // keine DBE ORDER Komponenten geladen
   IF ! DbeLoad( "DBFDBE" )
      MsgBox( "DBFDBE konnte nicht geladen werden" )
   ENDIF
   IF !DbeLoad( "NTXDBE", .T. )
      ALERT( MSG_DBFDBE_NOT_LOADED, { "OK" } )
   ENDIF
   IF !DbeBuild( "DBFNTX", "DBFDBE", "NTXDBE" )
      ALERT( MSG_DBFNTX_NOT_CREATED, { "OK" } )
   ENDIF

   IF ! DbeLoad( "FOXDBE" )
      MsgBox( "FOXDBE konnte nicht geladen werden" )
   ENDIF

   IF !DbeLoad( "CDXDBE", .T. )
      ALERT( "Database-Engine CDXDBE nicht geladen", { "OK" } )
   ENDIF
   IF !DbeBuild( "FOXCDX", "FOXDBE", "CDXDBE" )
      ALERT( "FOXCDX Database-Engine;konnte nicht erzeugt werden", { "OK" } )
   ENDIF

   DbeSetDefault( "DBFDBE" )
RETURN

 
PROCEDURE Main ( name )
   LOCAL nEvent, mp1, mp2, oXbp, oBrowse, aStruct, i, imax, bError, cDbe

   DEFAULT name TO GetFilename()

   IF name == NIL
      MsgBox ( "Keine Dateiname angegeben" + CHR(10) + CHR(10)+ ;
               "Aufruf: DBBrowse [<DbfName>]" )
      RETURN
   ENDIF
 
   bError := ErrorBlock( {|oErr| Break( oErr ) } )
*   cDBE   := "DBFDBE"
   cDBE   := "DBFNTX"
   FOR i:=1 TO 2
      BEGIN SEQUENCE
         DbUseArea( .T., cDBE, name )
      RECOVER
         
         IF i== 1
*            cDBE := "FOXDBE"
            cDBE := "FOXCDX"
            LOOP
         ENDIF
      ENDSEQUENCE
      EXIT
   NEXT
   ErrorBlock( bError )


   IF ! Used()
      MsgBox ( "Datei konnte nicht geffnet werden" + CHR(10) + CHR(10)+ name )
      QUIT
   ENDIF

   // Standard Dialog erzeugen
   oXbp := GuiStdDialog( "Standard GUI Browser fr DBF" )

   // Browser im Fenster erzeugen
   oBrowse := GuiBrowseDb( oXbp:drawingArea )

   // Fr alle Felder Spalten erzeugen, ohne FoxPro spezifische Datentypen
   imax    := FCount()
   aStruct := DbStruct()
   FOR i:=1 TO imax
      IF .NOT. aStruct[i,2] $ "BOVTXY"
         oBrowse:addColumn( FieldBlockTrimmed(aStruct[i,1], aStruct[i,2]), , aStruct[i,1] )
      ENDIF
   NEXT

   // Der Browser fllt das gesamte Fenster aus
   oXbp:drawingArea:resize := ;
       {|mp1,mp2,obj| obj:childList()[1]:setSize(mp2) }
 
   // Browser anzeigen und Focus geben
   oXbp:show()
   oBrowse:show()
   SetAppFocus( oBrowse )

   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO
RETURN
 
 
******************************************************************
* GUI Browser mit navigations Codebloecken erzeugen
******************************************************************
FUNCTION GuiBrowseDB( oParent, aPos, aSize )
   LOCAL oBrowse
 
   oBrowse := XbpBrowse():new( oParent,, aPos, aSize,, .F. ):create()

   // Navigations Codebloecke fuer den Browser
   oBrowse:skipBlock     := {|n| DbSkipper(n) }
   oBrowse:goTopBlock    := {| | DbGoTop()    }
   oBrowse:goBottomBlock := {| | DbGoBottom() }
   oBrowse:phyPosBlock   := {| | Recno()      }

   // Codebloecke fuer den vertikalen Scrollbar.
   // Hinweis: DbPosition() liefert Werte zwischen 0 und 100.
   // Wir multiplizieren das mit 10 um eine feinere Granularitaet
   // fuer den Scrollbar zu erreichen.
   oBrowse:posBlock      := {| | DbPosition()*10    }
   oBrowse:goPosBlock    := {|n| DbGoPosition(n/10) } 
   oBrowse:lastPosBlock  := {| | 1000               }
   oBrowse:firstPosBlock := {| | 0                  }
 
RETURN oBrowse
 

******************************************************************
* Standard Dialog unsichtbar erzeugen
******************************************************************
FUNCTION GuiStdDialog( cTitle )
   LOCAL oDlg
 
   DEFAULT cTitle TO "Standard Dialog Window"
 
   oDlg          := XbpDialog():new( ,,{10,10}, {600,400},, .F. )
   oDlg:icon     := 1
   oDlg:taskList := .T.
   oDlg:title    := cTitle
   oDlg:drawingArea:ClipChildren := .T.
   oDlg:create()
   oDlg:drawingArea:setFontCompoundName( FONT_DEFPROP_SMALL )
 
RETURN oDlg
 

******************************************************************
* Dateinamen mit Filedialog abfragen
******************************************************************
FUNCTION GetFilename()
   LOCAL oDlg := XbpFiledialog():New(), cFile

   oDlg:Title := "Bitte Datei auswaehlen"
   oDlg:Create()
   cFile := oDlg:Open( "..\..\DATA\*.DBF" )

RETURN cFile


****************************************************************************
* Daten-Codeblock fr Felder mit RTrim bei Strings
****************************************************************************
FUNCTION FieldBlockTrimmed( cFieldName, cType )
   LOCAL bBlock
   IF FieldPos( cFieldName ) <> 0
      IF ! "->" $ cFieldName
         cFieldName := "FIELD->"+cFieldName
      ENDIF
      IF cType = "C"
         bBlock := &( "{|x| IIf(x==NIL,RTrim("+cFieldName+"),"+cFieldName+":=x) }" )
      ELSE
         bBlock := &( "{|x| IIf(x==NIL,"+cFieldName+","+cFieldName+":=x) }" )
      ENDIF
   ENDIF
RETURN bBlock

// EOF
//////
